var _excluded = ["children", "limit", "ellipsis"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
var Badge = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$children = _ref.children,
      children = _ref$children === void 0 ? '0' : _ref$children,
      _ref$limit = _ref.limit,
      limit = _ref$limit === void 0 ? 2 : _ref$limit,
      _ref$ellipsis = _ref.ellipsis,
      ellipsis = _ref$ellipsis === void 0 ? '+' : _ref$ellipsis,
      others = _objectWithoutProperties(_ref, _excluded);

  // 标题
  var caption = children;

  if (limit && children && (typeof children === 'string' || typeof children === 'number')) {
    // 数字大于99,则显示99+
    if (!isNaN(children)) {
      caption = children.length > limit ? '99999'.substring(0, limit) + ellipsis : children;
    } else {
      caption = children.length > limit ? children.substring(0, limit) + ellipsis : children;
    }
  }

  return /*#__PURE__*/_jsx("span", _objectSpread(_objectSpread({
    ref: ref
  }, others), {}, {
    className: "badge".concat(others.className ? ' ' + others.className : ''),
    children: caption
  }));
});
export default Badge;