var _excluded = ["instance", "value", "onChange"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import Loading from "./../../../../Loading";
import Toast from "./../../../../Toast";
import { jsx as _jsx } from "react/jsx-runtime";

function Location(_ref) {
  var instance = _ref.instance,
      value = _ref.value,
      _onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, _excluded);

  function handleLocation() {
    if (!instance.current) return;
    Loading.show();
    instance.current.getLocation({
      onChange: function onChange(value) {
        Loading.hide();
        if (!value) return; // 视图更新

        instance.current.centerToPoint([value.longitude, value.latitude]);
        if (_onChange) _onChange(value);
      },
      onError: function onError(err) {
        Loading.hide();
        Toast.show(err.errMsg, {
          maskClickable: true
        });
      }
    });
  }

  return /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "map-location".concat(props.className ? ' ' + props.className : ''),
    onClick: handleLocation,
    children: /*#__PURE__*/_jsx("div", {
      className: "map-location-icon"
    })
  }));
}

export default Location;